#include <iostream>
#include <iomanip> 
#include <cmath>

using namespace std;


class Trojuhelnik {
    
public:

    double a,b,c, obv, obs, alfaRd, betaRd, gamaRd, alfaSt, betaSt, gamaSt, va,vb,vc;

    bool existuje();
    int strannost();
    int stupne();
    void obvod();
    void obsah();


};

int main() {

    Trojuhelnik tr;

    cout << "Zadejte velikost stran a b c:" << endl;
    cin >> tr.a >> tr.b >> tr.c;

    if(cin.fail() || tr.a<=0 || tr.b<=0 || tr.c<=0){
        cout << "Nespravny vstup." << endl;
        return (1);
    }

    if (!tr.existuje()) {

        cout << "Trojuhelnik neexistuje." << endl;
        return(0);

    } else { // existuje

        double pom = tr.strannost();
        if(pom==0) cout << "Trojuhelnik je rovnostranny." << endl;
        else if(pom==1) cout << "Trojuhelnik je rovnoramenny." << endl;
        else cout << "Trojuhelnik neni ani rovnostranny ani rovnoramenny." << endl;

        pom = tr.stupne();
        
        if(pom==0) cout << "Trojuhelnik je ostrouhly." << endl;
        else if(pom==1) cout << "Trojuhelnik je pravouhly." << endl;
        else cout << "Trojuhelnik je tupouhly." << endl;


        double stupne = floor(tr.alfaSt);
        double minuty = floor((tr.alfaSt-stupne)*60);
        double vteriny = ((tr.alfaSt-stupne-(minuty/60))*3600);
       // double setiny = round((((tr.alfaSt-stupne-(minuty/60))*3600) - vteriny) * 100);

        cout << "Uhel alfa: " << setprecision(4) << fixed << tr.alfaRd;
        cout <<" rad = " << setprecision(0) <<  stupne;
        cout << "s" << setw(2) << setfill('0') << minuty << "'";
        cout << setw(5) << setfill('0') << setprecision(2) << vteriny << "''" << endl;

        stupne = floor(tr.betaSt);
        minuty = floor((tr.betaSt-stupne)*60);
        vteriny = ((tr.betaSt-stupne-(minuty/60))*3600);
       // setiny = round((((tr.alfaSt-stupne-(minuty/60))*3600) - vteriny) * 100);

        cout << "Uhel beta: " << setprecision(4) << fixed << tr.betaRd;
        cout <<" rad = " << setprecision(0) <<  stupne;
        cout << "s" << setw(2) << setfill('0') << minuty << "'";
        cout << setw(5) << setfill('0') << setprecision(2) << vteriny << "''" << endl;

        stupne = floor(tr.gamaSt);
        minuty = floor((tr.gamaSt-stupne)*60);
        vteriny = ((tr.gamaSt-stupne-(minuty/60))*3600);
      //  setiny = round((((tr.alfaSt-stupne-(minuty/60))*3600) - vteriny) * 100);

        cout << "Uhel gama: " << setprecision(4) << fixed << tr.gamaRd;
        cout <<" rad = " << setprecision(0) <<  stupne;
        cout << "s" << setw(2) << setfill('0') << minuty << "'";
        cout << setw(5) << setfill('0') << setprecision(2) << vteriny << "''" << endl;

        tr.obvod();
        tr.obsah();

        cout << "Obvod: " << setprecision(2) << fixed << tr.obv << endl;
        cout << "Obsah: " << setprecision(2) << fixed << tr.obs << endl;

        cout << "Polomer kruznice vepsane: " << setprecision(2) << fixed << (tr.obs / (tr.obv/2)) << endl;
        cout << "Polomer kruznice opsane: " << setprecision(2) << fixed << ((tr.a * tr.b * tr.c)/(4*tr.obs)) << endl;

        tr.va = tr.b*sin(tr.gamaSt*M_PI/180);
        tr.vb = tr.a*sin(tr.gamaSt*M_PI/180);
        tr.vc = tr.a*sin(tr.betaSt*M_PI/180);

        cout << "Vyska va: " << setprecision(2) << fixed << tr.va << endl;
        cout << "Vyska vb: " << setprecision(2) << fixed << tr.vb << endl;
        cout << "Vyska vc: " << setprecision(2) << fixed << tr.vc << endl;

    }

    return (0);
}


bool Trojuhelnik::existuje(){

    if(a+b>c && a+c>b && b+c>a) return true; else return false;

}

int Trojuhelnik::strannost(){  // 0-rovnostranny; 1-rovnoramenny; 2-ani jedno

    if(a==b && b==c) return (0);
    if(a==b || a==c || b==c) return (1);

    return (2);

}

int Trojuhelnik::stupne(){ // 0-ostrouhly; 1-pravouhly; 2-tupouhly

    alfaRd = (pow(a,2) - pow(b,2) - pow(c,2)) / (-2*b*c);
    alfaRd = acos(alfaRd);
    alfaSt = alfaRd * 180 / M_PI ;

    betaRd = (pow(b,2) - pow(c,2) - pow(a,2)) / (-2*c*a);
    betaRd = acos(betaRd);
    betaSt = betaRd * 180 / M_PI;

    gamaRd = (pow(c,2) - pow(a,2) - pow(b,2)) / (-2*a*b);
    gamaRd = acos(gamaRd);
    gamaSt = gamaRd * 180 / M_PI;

    if(alfaSt<90 && betaSt<90 && gamaSt<90) return (0);
    if(alfaSt == 90 || betaSt==90 || gamaSt==90) return (1);

    return (2);

}

void Trojuhelnik::obvod(){
    obv = a+b+c;
}

void Trojuhelnik::obsah(){

    double pulObvod = obv/2;
    obs = sqrt(pulObvod*(pulObvod-a)*(pulObvod-b)*(pulObvod-c));

}
